From 8c4b9da4c039143940e0defcb9af08ac6a31efb2 Mon Sep 17 00:00:00 2001
From: Ralph Bean <rbean@redhat.com>
Date: Mar 14 2016 15:58:06 +0000
Subject: [PATCH 315/1001] Initial stubbing out of the groups page.


---

diff --git a/hubs/app.py b/hubs/app.py
index 39bea1f..6e4661d 100644
--- a/hubs/app.py
+++ b/hubs/app.py
@@ -70,6 +70,29 @@ def index():
     return flask.redirect(flask.url_for('hub', name=flask.g.auth.nickname))
 
 
+@app.route('/groups')
+def groups():
+    if not flask.g.auth.logged_in:
+        return flask.redirect(flask.url_for('login_fedora'))
+
+    # Get the list of promoted and non-promoted group hubs from the DB
+    promoted_names = app.config.get('PROMOTED_GROUPS')
+    groups = hubs.models.Hub.all_group_hubs(session)
+    promoted = [g for g in groups if g.name in promoted_names]
+    secondary = [g for g in groups if g.name not in promoted_names]
+
+    name_of_the_month = app.config.get('HUB_OF_THE_MONTH')
+    hub_of_the_month = hubs.models.Hub.by_name(session, name_of_the_month)
+
+    return flask.render_template(
+        'groups.html',
+        promoted=promoted,
+        secondary=secondary,
+        hub_of_the_month=hub_of_the_month,
+        session=session,
+    )
+
+
 @app.route('/<name>')
 @app.route('/<name>/')
 def hub(name):
diff --git a/hubs/default_config.py b/hubs/default_config.py
index 39d7fce..a21f138 100644
--- a/hubs/default_config.py
+++ b/hubs/default_config.py
@@ -1 +1,8 @@
 SECRET_KEY = 'changemeforreal'
+
+PROMOTED_GROUPS = [
+    'infra',
+    'i18n',
+]
+
+HUB_OF_THE_MONTH = 'commops'
diff --git a/hubs/models.py b/hubs/models.py
index ed003e3..cbe6371 100644
--- a/hubs/models.py
+++ b/hubs/models.py
@@ -209,6 +209,14 @@ class Hub(BASE):
     get = by_name
 
     @classmethod
+    def all_group_hubs(cls, session):
+        return session.query(cls).filter_by(user_hub=False).all()
+
+    @classmethod
+    def all_user_hubs(cls, session):
+        return session.query(cls).filter_by(user_hub=True).all()
+
+    @classmethod
     def create_user_hub(cls, session, username, fullname):
         hub = cls(name=username, summary=fullname,
                   avatar=username2avatar(username),
